#!C:\Programme\Python27\python.exe
# -*- coding: utf-8 -*-

# ***** include the biocase.lib directory in the python sys path for importing *****
import os, sys
execfile(os.path.abspath(os.path.join(os.path.dirname(__file__), os.path.pardir, os.path.pardir, 'lib', 'biocase', 'adjustpath.py')))

import cgitb
import string, subprocess
import biocase.configuration
from biocase.tools.various_functions import folder_not_writable
cgitb.enable()

cfg = biocase.configuration.Cfg()

print 'Content-Type: text/html'
print   # Blank line marking end of HTTP headers

print '''<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Python library tests</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="../resources/css/biocase.css" rel="stylesheet" type="text/css">
<link rel="SHORTCUT ICON" href="../resources/images/favicon.ico">
</head>

<body>

<!-- HEADER -->
<div id="Header">
Python Library Tests
</div>
<div id="NavBar"><a href="../index.cgi">Start</a> <span class="breadcrumbSeparator">&raquo;</span> <a href="index.html">Utilities</a> <span class="breadcrumbSeparator">&raquo;</span><strong>Test libraries</strong> </div>

<div id="Content">

<h2>Python Interpreter: %s </span></h2>''' % string.join([str(i) for i in sys.version_info[:3]], ".")

print '''<span class="goodstatus">green:</span> Ok! | <span class="badstatus">red:</span> you have to install it | <span class="dependstatus">orange:</span> install only if required

<!-- START REQUIRED LIBS TABLES -->
<h2>Libraries required for core wrapper</h2>
      <table>
        <tr >
          <th width="120"><strong>Library</strong></th>
          <th width="120"><strong>Installed Version</strong></th>
          <th width="360"><strong>Hint</strong></th>
        </tr>'''

# biocase libs
print '''
        <tr >
          <td>BioCASe</td>
          <td>'''
try:
    import biocase.tools.update
    print '<span class="goodstatus">' + biocase.__version__ + '</span>'
except Exception, err:
    print '<span class="dependstatus" title="%s">not installed</span>' % err

print '</td><td>%s</td></tr></table>' % biocase.tools.update.update_hint()


# QueryTool
print'''<h4>&nbsp;</h4>
<h2>Libraries only needed for querytool</h2>
      <table>
        <tr >
          <th width="120"><strong>Library</strong></th>
          <th width="120"><strong>Installed Version</strong></th>
          <th width="360"><strong>Hint</strong></th>
        </tr>
'''
# libxml2/libxslt
print '''
        <tr >
          <td>libxml2/libxslt</td>
          <td>'''
try:
    import libxml2, libxslt
    print '<span class="goodstatus">installed</span>'
except Exception, err:
    print '<span class="dependstatus" title="%s">not installed</span>' % err

print '''</td>
            <td>You need to install both libxml2, libxslt <strong>and their Python bindings</strong> for this. On Windows, you do this with a single installer you can find <a href="http://users.skynet.be/sbi/libxml-python/" target="_blank">here</a>. On most Linuxes, you can use the package installer, or visit <a target="_blank" href="http://xmlsoft.org/downloads.html">this website</a>.</td>
        </tr>'''

# 4suite
print '''
        <tr >
          <td>4Suite XML</td>
          <td>'''
try:
    import Ft
    print '<span class="goodstatus">' + Ft.__version__ + '</span>'
except Exception, err:
    print '<span class="dependstatus" title="%s">not installed</span>' % err

print '''</td>
            <td><a href="http://sourceforge.net/projects/foursuite/">4Suite XML</a></td>
        </tr></table><br>
        <p><img src="../resources/images/tooltip.png"/> You only need to install either 4Suite XML <strong>or</strong> libxml2/libxslt +  Python bindings. BioCASe will use whichever is installed. <br>Note that 4Suite XML is not available for Python versions later than 2.5.</p>'''


# HTML
print '''

<!-- START DRIVER TABLES -->
<h4>&nbsp;</h4>
<h2>Status of additional database dependent drivers</h2>
      <table>
        <tr >
          <th width="120"><strong>Library</strong></th>
          <th width="120"><strong>Installed Version</strong></th>
          <th width="360"><strong>Download Library</strong></th>
        </tr>'''

# ceODBC
print '''        <tr >
          <td>ceODBC</td>
          <td>'''
try:
    import ceODBC
    print '<span class="goodstatus">' + ceODBC.version + '</span>'
except Exception, err:
    print '<span class="dependstatus" title="%s">not installed</span>' % err


print '''</td>
            <td><a href="http://ceodbc.sourceforge.net/">ceODBC module</a></td>
        </tr>'''

# pyODBC
print '''        <tr >
          <td>pyodbc</td>
          <td>'''
try:
    import pyodbc
    print '<span class="goodstatus">' + pyodbc.version + '</span>'
except Exception, err:
    print '<span class="dependstatus" title="%s">not installed</span>' % err


print '''</td>
            <td><a href="http://mkleehammer.github.io/pyodbc/">pyodbc module</a></td>
        </tr>'''

# pymssql
print '''        <tr >
          <td>pymssql</td>
          <td>'''
try:
    import pymssql
    print '<span class="goodstatus">' + pymssql.__version__ + '</span>'
except Exception, err:
    print '<span class="dependstatus" title="%s">not installed</span>' % err

print '''</td>
            <td>
            <a href="http://sourceforge.net/projects/pymssql/files/pymssql">MS SQL Server module</a></td>
        </tr>'''


# psycopg2
print '''
        <tr >
          <td>psycopg2</td>
          <td>'''
try:
    import psycopg2
    print '<span class="goodstatus">' + psycopg2.__version__ + '</span>'
except Exception, err:
    print '<span class="dependstatus" title="%s">not installed</span>' % err

print '''</td>
            <td>PostgreSQL module (<a href="http://initd.org/software/initd/psycopg">Linux</a>/<a href="http://stickpeople.com/projects/python/win-psycopg/">Win</a>)</td>
        </tr>'''


# MySQLdb
print '''
        <tr >
          <td>MySQLdb</td>
          <td>'''
try:
    import MySQLdb
    print '<span class="goodstatus">' + MySQLdb.__version__ + '</span>'
except Exception, err:
    print '<span class="dependstatus" title="%s">not installed</span>' % err

print '''</td>
            <td><a href="http://sourceforge.net/projects/mysql-python/">mySQL module</a></td>
        </tr>'''


# cx_Oracle
print '''
        <tr >
          <td>cx_Oracle</td>
          <td>'''
try:
    import cx_Oracle
    print '<span class="goodstatus">' + cx_Oracle.version + '</span>'
except Exception, err:
    print '<span class="dependstatus" title="%s">not installed</span>' % err

print '''</td>
            <td><a href="http://cx-oracle.sourceforge.net/">Oracle module</a>, you also need the <a href="http://www.oracle.com/technetwork/database/index.html">Oracle Client</a></td>
        </tr>'''


# kinterbasdb
print '''
        <tr >
          <td>kinterbasdb</td>
          <td>'''
try:
    import kinterbasdb
    print '<span class="goodstatus">' + string.join([str(x) for x in kinterbasdb.__version__], ".") + '</span>'
except Exception, err:
    print '<span class="dependstatus" title="%s">not installed</span>' % err

print '''</td>
            <td><a href="http://kinterbasdb.sourceforge.net/">Firebird/Interbase module</a></td>
        </tr>'''

# SQLlite
print '''
        <tr >
          <td>SQLlite</td>
          <td>'''
try:
    import sqlite3
    print '<span class="goodstatus">' + sqlite3.version + '</span>'
except Exception, err:
    print '<span class="dependstatus" title="%s">not installed</span>' % err

print '''</td>
            <td>(integrated into Python)</td>
        </tr>
'''

# Sybase
print '''
        <tr >
          <td>Sybase</td>
          <td>'''
try:
    import Sybase
    print '<span class="goodstatus">' + Sybase.__version__ + '</span>'
except Exception, err:
    print '<span class="dependstatus" title="%s">not installed</span>' % err

print '''</td>
            <td><a href="http://www.object-craft.com.au/projects/sybase/">Sybase module</a></td>
        </tr>
</table>
<br>
<p><img src="../resources/images/tooltip.png"/>
If you can't find the Windows installer package for your Python version, try your luck <a href="http://www.lfd.uci.edu/~gohlke/pythonlibs/" target="_blank">here</a>.
<br>For ODBC, you need to install <i>either</i> ceODBC or pyodbc; BioCASe will use whichever is installed.</p>
'''

# DETECT GRAPHVIZ, external binaries
try:
    proc = subprocess.Popen([cfg.server.graphviz_dot, '-V'], stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    version = proc.stderr.readline().replace('dot - graphviz version', '')
    graphviz_status = '<span class="goodstatus">%s</span>' % version
except:
    graphviz_status = '<span class="badstatus">%s</span>' % "Binary not found"

# Java
try:
    proc = subprocess.Popen([cfg.server.java, '-version'], stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    version = proc.stderr.readline().replace('version ', '').replace('"', '')
    java_status = '<span class="goodstatus">%s</span>' % version
except Exception, err:
    java_status = '<span class="badstatus">%s</span>' % "Binary not found"

print '''
<h4>&nbsp;</h4>
<h2>Optional external binaries</h2>
      <table>
        <tr >
          <th width="120"><strong>Binary</strong></th>
          <th width="120"><strong>Status/Version</strong></th>
          <th width="360"><strong>Path</strong></th>
        </tr>
        <tr >
          <td>%s</td>
          <td>%s</td>
          <td>%s</td>
        </tr>
        <tr >
          <td>%s</td>
          <td>%s</td>
          <td>%s</td>
        </tr>
      </table>
''' % ('<a href="http://www.graphviz.org/Download.php">Graphviz Dot</a>', graphviz_status, cfg.server.graphviz_dot,
      '<a href="http://www.java.com/de/download/">Java</a>', java_status, cfg.server.java)

statusCfg = folder_not_writable(cfg.configurationLocator)
if statusCfg is None:
    config_folder_writable_status = '<span class="goodstatus">Writeable</span>'
else:
    config_folder_writable_status = '<span class="badstatus">Unwriteable</span>'

statusLog = folder_not_writable(cfg.logLocator)
if statusLog is None:
    log_folder_writable_status = '<span class="goodstatus">Writeable</span>'
else:
    log_folder_writable_status = '<span class="badstatus">Unwriteable</span>'

statusArchiveWork = folder_not_writable(cfg.archiveWorkLocator)
if statusArchiveWork is None:
    awrk_folder_writable_status = '<span class="goodstatus">Writeable</span>'
else:
    awrk_folder_writable_status = '<span class="badstatus">Unwriteable</span>'

statusArchiveDownload = folder_not_writable(cfg.archiveDownloadLocator)
if statusArchiveDownload is None:
    adld_folder_writable_status = '<span class="goodstatus">Writeable</span>'
else:
    adld_folder_writable_status = '<span class="badstatus">Unwriteable</span>'

# HTML
print '''
<h4>&nbsp;</h4>
<h2>Status of writable directories and files</h2>
      <table>
        <tr >
          <th width="120"><strong>Directory</strong></th>
          <th width="120"><strong>Status</strong></th>
          <th width="360"><strong>Path to problematic file</strong></th>
        </tr>
        <tr >
          <td>Configuration</td>
          <td>%s</td>
          <td>%s</td>
        </tr>
        <tr >
          <td>Log</td>
          <td>%s</td>
          <td>%s</td>
        </tr>
        <tr >
          <td>Archive temp dir</td>
          <td>%s</td>
          <td>%s</td>
        </tr>
        <tr >
          <td>Archive download Dir</td>
          <td>%s</td>
          <td>%s</td>
        </tr>
      </table>
''' % (config_folder_writable_status, str(statusCfg), log_folder_writable_status, str(statusLog), awrk_folder_writable_status, str(statusArchiveWork), adld_folder_writable_status, str(statusArchiveDownload))

print '''
</div>

<!-- FOOTER -->

<div id="Footer">
  <a href="http://www.biocase.org"><img src="../resources/images/biocase_powered.gif" width="112" height="34"></a>
</div>

</body>
</html>
'''
